local M = {}

----------------------------------------------------------------------------------------------------
-- Imports
----------------------------------------------------------------------------------------------------

local crashbreaker = require("scenario/intersection/handlers/crashbreaker")

local ClassStandardCrashbreaker = require("scenario/intersection/classes/crashbreaker/classStandard")

----------------------------------------------------------------------------------------------------

local function setCrashbreaker(cb)
    --[[
    Sets the crashbreaker
    ]]--
    crashbreaker.setCrashbreaker(cb)
end

local function resetCrashbreaker()
    --[[
    Resets the crashbreaker
    ]]--
    local cb = crashbreaker.getCrashbreaker()

    if not cb then
        return
    end

    cb:reset()
    cb:updateUI({requirement = cb:getRequirement()})

    if not cb:instanceOf("ClassStandardCrashbreaker") then
        -- Convert the class back to the standard version
        cb = ClassStandardCrashbreaker:convert(ClassStandardCrashbreaker, cb)
    end
end

local function reset()
    --[[
    Resets the crashbreaker to its initial state
    ]]--
    resetCrashbreaker()
end

local function resetState()
    --[[
    Resets the crashbreaker to its initial state
    ]]--
    reset()
end

M.setCrashbreaker = setCrashbreaker
M.resetCrashbreaker = resetCrashbreaker
M.reset = reset
M.resetState = resetState
return M