angular.module('beamng.apps')
.directive('intersectionStatistics', ['bngApi', function(bngApi) {
  return {
    templateUrl: 'modules/intersection/apps/Statistics/templateBMNG.html',
    replace: true,
    link: function (scope, element, attrs) {
      'use strict';

      /**
       * Returns the specific colour of a medal
       * @param {String} medal - the name of the medal
       * @return {String} - the medal colour string
       */
      function medalToColour(medal) {
        medal = medal.toLowerCase();

        if (medal === "bronze") {
          return "#CD7F32";
        } else if (medal === "silver") {
          return "#C0C0C0";
        } else if (medal === "gold") {
          return "#FFD700";
        } else if (medal === "chaos") {
          return "#B9F2FF";
        } else if (medal === "best") {
          return "#00ff00";
        } else {
          return "#FF0000";
        }
      }

      /**
       * Displays the medal totals
       * @param {Object} data - contains the medal,total pairs for each medal
       */
      scope.$on("i_display_stats", function(event, data) {
        for (let medal in data) {
          // Uppercase first letter
          let medalName = medal.substring(0, 1).toUpperCase() + medal.substring(1);
          document.getElementById("total" + medalName).innerHTML = data[medal];
        }
      });
    }
  };
}]);
